// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  TU Dresden                                                            ==
// ==                                                                        ==
// ==  Institut fr Wissenschaftliches Rechnen                               ==
// ==  Zellescher Weg 12-14                                                  ==
// ==  01069 Dresden                                                         ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  https://gforge.zih.tu-dresden.de/projects/amdis/                      ==
// ==                                                                        ==
// ============================================================================

/** \file RefinementManager1d.h */

#ifndef AMDIS_REFINEMENT_MANAGER_1D_H
#define AMDIS_REFINEMENT_MANAGER_1D_H

namespace AMDiS {

  /** \ingroup Adaption
   * \brief
   * Implements a RefinementManager for 1-dimensional meshes.
   */
  class RefinementManager1d : public RefinementManager
  {
  public:
    /// Calls base class constructor.
    RefinementManager1d()
      : RefinementManager()
    {}

    /// destructor 
    virtual ~RefinementManager1d() {}

    /// Implements RefinementManager::refineMesh.
    Flag refineMesh(Mesh *aMesh);

    /// Implements RefinementManager::setNewCoords
    void setNewCoords();

  protected:
    /// Used by refineMesh while mesh traversal
    static int recursiveRefineFunction(ElInfo* el_info);

    /// Used by \ref setNewCoords
    static int newCoordsFct(ElInfo *el_info);
  };

}

#endif // AMDIS_REFINEMENT_MANAGER_1D_H
